/* APImWindows̎dg */
/* Part 8 list 2 ȗ */
/* CriticalSectionŃXbhԂ̓A"global_count"
JEgAbvTvB */
/* cl /MT %.cpp ..\PrintErrorMsg.obj */

#include <windows.h>
#include <stdio.h>
#include <process.h>

#include "..\PrintErrorMsg.h"

typedef struct {
	int n;
	int count;
} COUNTER;

int global_count = 0;

CRITICAL_SECTION critsec;

unsigned int __stdcall countup(void *args)
{
	COUNTER *c = (COUNTER*)args;
	int tmp;
	while (c->count < 10)
	{
		EnterCriticalSection(&critsec);

		tmp = global_count;
		printf("Thread[%d], Count[%d]\n", c->n, c->count);
		c->count++;
		global_count = tmp + 1;

		LeaveCriticalSection(&critsec);

		Sleep(100);
	}
	return c->count;
}

int main(void)
{
	COUNTER *args = NULL;
	int i;
	HANDLE hThread;
	unsigned int threadId;

	InitializeCriticalSection(&critsec);

	for (i = 0; i < 5; i++) {
		args = (COUNTER*)malloc(sizeof(COUNTER));
		if (NULL == args) {
			printf("args allocation error.\n");
			return -1;
		}
		args->n = i;
		args->count = 0;
		hThread = (HANDLE)_beginthreadex(
			NULL, 0, countup, args, 0, &threadId);
		if (0 == hThread) {
			printf("_beginthreadex() error.\n");
			return -2;
		}
		CloseHandle(hThread);
	}
	Sleep(5 * 1000);
	printf("\nGlobal Count = %d\n", global_count);

	DeleteCriticalSection(&critsec);
	return 0;
}
