/* APImWindows̎dg */
/* Part 13 list 1, 2, 4 */
/* EChE\Ă݂B{^NbNŃbZ[W{bNX\B */
/* cl %.cpp user32.lib advapi32.lib */
#include <windows.h>
#include <stdio.h>

#define BEEPSERVICE_NAME "BeepServices"

SERVICE_STATUS_HANDLE g_ssh = NULL;
HANDLE g_event = NULL;
HANDLE g_event2 = NULL;
DWORD g_state = SERVICE_STOPPED;

void WINAPI BeepServiceMain(DWORD, LPTSTR*);
void WINAPI BeepServiceHandler(DWORD);

int main(void)
{
	SERVICE_TABLE_ENTRY services[] = {
		{"BeepService", BeepServiceMain},
		{NULL, NULL}
	};
	
	if (!StartServiceCtrlDispatcher(services)) {
		MessageBox(NULL,
			"error occurred in BeepService.",
			"BeepService error", 
			MB_OK | MB_ICONERROR | MB_SERVICE_NOTIFICATION);
	}

	return 0;
}

void WINAPI BeepServiceMain(DWORD dwArgc, LPTSTR *lpszArgv)
{
	// nho^
	g_ssh = RegisterServiceCtrlHandler(
		BEEPSERVICE_NAME, BeepServiceHandler);
	if (NULL == g_ssh) {
		MessageBox(NULL,
			"Couldn't start BeepService.",
			"BeepService error", 
			MB_OK | MB_ICONERROR | MB_SERVICE_NOTIFICATION);
		return;
	}
	
	// CxgEIuWFNg쐬BԂ̓Zbg
	g_event = CreateEvent(NULL, FALSE, FALSE, NULL);
	g_event2 = CreateEvent(NULL, FALSE, FALSE, NULL);
	g_state = SERVICE_RUNNING;
	
	// I|[g
	SERVICE_STATUS status = {
		SERVICE_WIN32_OWN_PROCESS,
		SERVICE_RUNNING,
		SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_PAUSE_CONTINUE,
		0, 0, 0, 0};
	SetServiceStatus(g_ssh, &status);
	
	OutputDebugString("Now BeepService service started.\n");

	// T[rXA2bBeep炷B
	while (true) {
		Beep(440, 200); // 440Hz̉0.2b
	
		// ʒmő2bԑ҂
		if (WAIT_TIMEOUT == WaitForSingleObject(g_event, 2000)) {
			// ^CAEgȂAŵŃ[v擪=Beep()ɖ߂B
			continue;
		}
		
		// ꎞ~̒ʒmꍇ͍ĊJʒm҂
		while (SERVICE_PAUSED == g_state) {
			SetEvent(g_event2); // nhpEventɂ͒ʒmĂB
			// nh̍ĊJʒmCxg𖳊ҋ@
			WaitForSingleObject(g_event, INFINITE);
		}
		
		if (SERVICE_RUNNING == g_state) {
			// nhɊʒm
			SetEvent(g_event2);
		} else if (SERVICE_STOPPED == g_state) {
			// T[rX~
			break;
		}
	}
	
	OutputDebugString("Terminated BeepService service.\n");
	// nhɊʒm
	SetEvent(g_event2);
}

void WINAPI BeepServiceHandler(DWORD fdwControl)
{
	char buf[256];

	SERVICE_STATUS status = {
		SERVICE_WIN32_OWN_PROCESS,
		SERVICE_RUNNING,
		SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_PAUSE_CONTINUE,
		0, 0, 0, 0};

	switch (fdwControl) {
	case SERVICE_CONTROL_PAUSE:
		g_state = SERVICE_PAUSED;
		OutputDebugString("pausing.\n");
		// T[rXnhɒʒm
		SetEvent(g_event);
		// T[rXnh̊ʒmҋ@
		WaitForSingleObject(g_event2, INFINITE);
		break;

	case SERVICE_CONTROL_CONTINUE:
		g_state = SERVICE_RUNNING;
		OutputDebugString("restarting.\n");
		// T[rXnhɒʒm
		SetEvent(g_event);
		// T[rXnh̊ʒmҋ@
		WaitForSingleObject(g_event2, INFINITE);
		break;

	case SERVICE_CONTROL_STOP:
		g_state = SERVICE_STOPPED;
		OutputDebugString("stopped.\n");
		// T[rXnhɒʒm
		SetEvent(g_event);
		// T[rXnh̊ʒmҋ@
		WaitForSingleObject(g_event2, INFINITE);
		break;
	
	case SERVICE_CONTROL_INTERROGATE:
		break;
	default:
		sprintf(buf, "Unknown control code: 0x%08lx\n", fdwControl);
		OutputDebugString(buf);
	}
	
	status.dwCurrentState = g_state;
	SetServiceStatus(g_ssh, &status);
	return;
}
