// Vvȕ񃊃\[X擾Tv
// > cl string_res01.c user32.lib string_res01.res
#include <windows.h>
#include <stdio.h>

#include "resource.h"

void PrintErrorMsg(DWORD err);
void PrintStringResource(HINSTANCE hInst, unsigned int id);

int main(int argc, char *argv[])
{
	HINSTANCE hCurrentInst = GetModuleHandle(NULL);

	// ʏ핶񃊃\[X
	PrintStringResource(hCurrentInst, IDS_STRING1);

	// ̕񃊃\[X
	PrintStringResource(hCurrentInst, IDS_STRING2);

	// ݂Ȃ񃊃\[X
	PrintStringResource(hCurrentInst, 0);

	return 0;
}

void PrintStringResource(HINSTANCE hInst, unsigned int id)
{
	int r = 0;
	char buf[1024];
	DWORD dwLastError;

	// LoadString()0ԂΏ̂߁ALastError0NAĂB
	SetLastError(0);

	r = LoadString(
		hInst, id, 
		buf, sizeof(buf)/sizeof(buf[0])
	);
	if (0 == r) {
		// 󕶎̃\[XIDw肷LoadString()0Ԃ̂ŁA
		// GetLastError()ăG[0Ȃ̂A󕶎(=)0Ȃ̂
		// ʂB
		dwLastError = GetLastError();
		if (0 != dwLastError) {
			printf("Resource(%d) error.\n", id);
			PrintErrorMsg(dwLastError);
			return;
		}
	}
	printf("LoadString() returns %d\n", r);
	printf("Resource(%d) : [%s]\n", id, buf);
	return;
}

void PrintErrorMsg(DWORD err)
{
	LPTSTR lpMsgBuf;
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER
		| FORMAT_MESSAGE_FROM_SYSTEM 
		| FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL, err,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("%s\n", lpMsgBuf);
	LocalFree(lpMsgBuf);
}
